import jec.dto.ADUserDTO;
import java.util.ArrayList;
import jec.ActiveDirectoryConnector;

public class ADConnectorExamples {


    private static void activeDirectoryExamples()

    {

        // The URL of your LDAP server. Most likely this is in the following format:
        // ldap://[ip address of exchange server]:389
        String sLdapServerUrl = "ldap://10.13.1.2:389";

        //String sAdLdapStart = "CN=Users,DC=CELLTREX,DC=com";
        String sAdLdapStart = "OU=qa,DC=CELLTREX,DC=com";

        String sApplicationUserCN = "Administrator";
        String sApplicationUserPassword = "qapass";

        try {
            // Create a bridge object:
            ActiveDirectoryConnector activeDirectoryConnector = new
                    ActiveDirectoryConnector
                    (sLdapServerUrl,
                     sAdLdapStart);

            // Connect, using an appropriate login:
            activeDirectoryConnector.connect(sApplicationUserCN,
                                             sApplicationUserPassword);
            System.out.println("connected.");
            /*
                        // Get all the users in Active Directory. This returns a Vector of ADUser objects.
             ArrayList vecAllUsers = activeDirectoryConnector.getAllUsers();
             System.out.println("num of users: " + vecAllUsers.size());
                        for (int i=0; i < vecAllUsers.size(); i++) {
                          System.out.println ( "User" + i );
             System.out.println (    ( (ADUserDTO)vecAllUsers.get(i) ).getDisplayName() ) ;
             System.out.println (    ( (ADUserDTO)vecAllUsers.get(i) ).getMailBoxName() ) ;
             System.out.println (    ( (ADUserDTO)vecAllUsers.get(i) ).getEmailAddress() ) ;
             System.out.println (    ( (ADUserDTO)vecAllUsers.get(i) ).getForename() ) ;
             System.out.println (    ( (ADUserDTO)vecAllUsers.get(i) ).getAccountName() ) ;
                          System.out.println();
                        }

            ArrayList users1 = activeDirectoryConnector.getUsers(
                    "mail=*@CELLTREX.COM");
            System.out.println("num of users1: " + users1.size());
            for (int i = 0; i < users1.size(); i++) {
                System.out.println("User" + i);
                System.out.println(((ADUserDTO) users1.get(i)).getDisplayName());
                System.out.println(((ADUserDTO) users1.get(i)).getMailBoxName());
                System.out.println(((ADUserDTO) users1.get(i)).getEmailAddress());
                System.out.println(((ADUserDTO) users1.get(i)).getForename());
                System.out.println(((ADUserDTO) users1.get(i)).getAccountName());
                System.out.println();

            }*/

            // open the comments to try the following filters
            // The interpretation of filterExpr is based on RFC 2254

            // email adderss is Domain is : CELLTREX.COM
//            ArrayList users2 = activeDirectoryConnector.getUsers("mail=*@CELLTREX.COM");


            // objectClass is person AND the email adderss is Domain is : CELLTREX.COM
            //ArrayList users2 = activeDirectoryConnector.getUsers("(&(mail=*@CELLTREX.COM) (objectClass=person) )");

            // email adderss is Domain is : CELLTREX.COM AND the user name ends with "alone"
            //ArrayList users2 = activeDirectoryConnector.getUsers("(&(mail=*@CELLTREX.COM) (name=*alon) )");

            // email adderss is Domain is : CELLTREX.COM OR the user name ends with "alone"
            //ArrayList users2 = activeDirectoryConnector.getUsers("(|(mail=*@CELLTREX.COM) (name=*alon) )");

            ArrayList users2 = activeDirectoryConnector.getUsers("(&(mail=*@CELLTREX.COM) (!(displayName=*alon)) )");
            System.out.println("num of users2: " + users2.size());
            for (int i=0; i < users2.size(); i++) {
                System.out.println("User" + i);
                System.out.println(((ADUserDTO) users2.get(i)).getDisplayName());
                System.out.println(((ADUserDTO) users2.get(i)).getMailBoxName());
                System.out.println(((ADUserDTO) users2.get(i)).getEmailAddress());
                System.out.println(((ADUserDTO) users2.get(i)).getForename());
                System.out.println(((ADUserDTO) users2.get(i)).getAccountName());
                System.out.println();
            }

        } catch (Exception ade) {
            ade.printStackTrace();
        }

    }

    public static void main(String[] args) {
        activeDirectoryExamples();
    }


}
