import java.util.ArrayList;
import jec.dto.ADUserDTO;
import java.util.Date;
import jec.dto.ExchangeEventDTO;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import jec.ActiveDirectoryConnector;
import jec.ExchangeConnectorFactory;
import jec.ExchangeConnectorInterface;


/**
 * to run this example you need commercial license since it creates
 * more then one instance of JEC.
 *
 */
public class CombinedADExchangeExample {

    private static final String sLdapServerUrl = "ldap://10.13.1.2:389";
    private static final String sAdLdapStart = "CN=Users,DC=CELLTREX,DC=com";
    private static final String sApplicationUserCN = "Administrator";
    private static final String sApplicationUserPassword = "qapass";

    private static final String _exchangeHost = "10.13.1.2";
    private static final String _prefix = "Exchange";
    private static final String userpass = "1234";

    public static void combinedExample1() {
        ActiveDirectoryConnector adBridge = new ActiveDirectoryConnector
                                            (sLdapServerUrl,
                                             sAdLdapStart);
        ExchangeConnectorFactory factory = new ExchangeConnectorFactory();
        ExchangeConnectorInterface connector = null;

        try {
            adBridge.connect(sApplicationUserCN,
                             sApplicationUserPassword);
            System.out.println("connected to AD.");

            ArrayList vecAllUsers = adBridge.getAllUsers();
            System.out.println("num of users: " + vecAllUsers.size());
            for (int i = 0; i < vecAllUsers.size(); i++) {

                if ((((ADUserDTO) vecAllUsers.get(i)).getDisplayName() != null) &&
                    ((ADUserDTO) vecAllUsers.get(i)).getDisplayName().
                    startsWith("eli")) {
                    String userAccountName = ((ADUserDTO) vecAllUsers.get(i)).
                                             getAccountName();
                    String userMailboxName = ((ADUserDTO) vecAllUsers.get(i)).
                                             getMailBoxName();
                    System.out.println("DisplayName: " +
                                       ((ADUserDTO) vecAllUsers.get(i)).
                                       getDisplayName() + " mailboxName: " +
                                       userMailboxName + " AccountName: " +
                                       userAccountName);
                    connector = factory.createExchangeConnector(_exchangeHost,
                            userAccountName,
                            userpass,
                            _prefix, false, userMailboxName);

                    SimpleDateFormat dateFormat = new SimpleDateFormat(
                            "yyyy-MM-dd HH:mm:ss");
                    Date startDate = null;
                    Date endDate = null;
                    try {
                        startDate = dateFormat.parse("2006-11-30 06:00:00");
                        endDate = dateFormat.parse("2006-11-31 21:00:00");
                    } catch (ParseException ex) {
                        ex.printStackTrace();
                    }
                    System.out.println("getting events from startDate: " +
                                       startDate + " to endDate: " + endDate);

                    ArrayList events = connector.getEvents(startDate,
                            endDate, 5);
                    for (int j = 0; j < events.size(); j++) {
                        System.out.println("event " + j + " subject: " +
                                           ((ExchangeEventDTO) events.get(j)).
                                           getSubject());
                    }

                }

                System.out.println();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    public static void main(String[] args) {
        combinedExample1();
    }
}
